package com.c4biz.hawkdev.ide.ui.composites;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.c4biz.hawdev.model.organization.KnowledgeOrganization;

public class OrganizationEditor extends Composite {

	private DataBindingContext m_bindingContext;
	private KnowledgeOrganization knowledgeOrganization;
	private Text idText;
	private Text nameText;
	private Text creationDateText;
	private Text lastModificationText;
	private Text descriptionText;

	public OrganizationEditor(
			Composite parent,
			int style,
			KnowledgeOrganization newKnowledgeOrganization) {
		this(parent, style);
		setKnowledgeOrganization(newKnowledgeOrganization);
	}

	public OrganizationEditor(Composite parent, int style) {
		super(parent, style);
		setLayout(new GridLayout(2, false));

		new Label(this, SWT.NONE).setText("Id:");

		idText = new Text(this, SWT.BORDER | SWT.SINGLE);
		idText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		new Label(this, SWT.NONE).setText("Name:");

		nameText = new Text(this, SWT.BORDER | SWT.SINGLE);
		nameText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		new Label(this, SWT.NONE).setText("CreationDate:");

		creationDateText = new Text(this, SWT.BORDER | SWT.SINGLE);
		creationDateText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false));

		new Label(this, SWT.NONE).setText("LastModification:");

		lastModificationText = new Text(this, SWT.BORDER | SWT.SINGLE);
		lastModificationText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER,
				true, false));

		new Label(this, SWT.NONE).setText("Description:");

		descriptionText = new Text(this, SWT.BORDER | SWT.SINGLE);
		descriptionText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false));

		if (knowledgeOrganization != null) {
			m_bindingContext = initDataBindings();
		}
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	private DataBindingContext initDataBindings() {
		IObservableValue idObserveWidget = SWTObservables.observeText(idText,
				SWT.FocusOut);
		IObservableValue idObserveValue = EMFObservables
				.observeValue(
						knowledgeOrganization,
						com.c4biz.hawkdev.model.common.CommonPackage.Literals.ABS_IDENTIFIED_CLASS__ID);
		IObservableValue nameObserveWidget = SWTObservables.observeText(
				nameText, SWT.Modify);
		IObservableValue nameObserveValue = EMFObservables
				.observeValue(
						knowledgeOrganization,
						com.c4biz.hawkdev.model.common.CommonPackage.Literals.ABS_NAMED_CLASS__NAME);
		IObservableValue creationDateObserveWidget = SWTObservables
				.observeText(creationDateText, SWT.FocusOut);
		IObservableValue creationDateObserveValue = EMFObservables
				.observeValue(
						knowledgeOrganization,
						com.c4biz.hawkdev.model.common.CommonPackage.Literals.ABS_COMMON_CONTAINER__CREATION_DATE);
		IObservableValue lastModificationObserveWidget = SWTObservables
				.observeText(lastModificationText, SWT.FocusOut);
		IObservableValue lastModificationObserveValue = EMFObservables
				.observeValue(
						knowledgeOrganization,
						com.c4biz.hawkdev.model.common.CommonPackage.Literals.ABS_COMMON_CONTAINER__LAST_MODIFICATION);
		IObservableValue descriptionObserveWidget = SWTObservables.observeText(
				descriptionText, SWT.Modify);
		IObservableValue descriptionObserveValue = EMFObservables
				.observeValue(
						knowledgeOrganization,
						com.c4biz.hawkdev.model.common.CommonPackage.Literals.ABS_DESCRIBED_CLASS__DESCRIPTION);
		//
		DataBindingContext bindingContext = new DataBindingContext();
		//
		bindingContext.bindValue(idObserveWidget, idObserveValue,
				new org.eclipse.core.databinding.UpdateValueStrategy(
						UpdateValueStrategy.POLICY_NEVER), null);
		bindingContext.bindValue(nameObserveWidget, nameObserveValue, null,
				null);
		bindingContext.bindValue(creationDateObserveWidget,
				creationDateObserveValue,
				new org.eclipse.core.databinding.UpdateValueStrategy(
						UpdateValueStrategy.POLICY_NEVER), null);
		bindingContext.bindValue(lastModificationObserveWidget,
				lastModificationObserveValue,
				new org.eclipse.core.databinding.UpdateValueStrategy(
						UpdateValueStrategy.POLICY_NEVER), null);
		bindingContext.bindValue(descriptionObserveWidget,
				descriptionObserveValue, null, null);
		//
		return bindingContext;
	}

	public com.c4biz.hawdev.model.organization.KnowledgeOrganization getKnowledgeOrganization() {
		return knowledgeOrganization;
	}

	public void setKnowledgeOrganization(
			com.c4biz.hawdev.model.organization.KnowledgeOrganization newKnowledgeOrganization) {
		setKnowledgeOrganization(newKnowledgeOrganization, true);
	}

	public void setKnowledgeOrganization(
			com.c4biz.hawdev.model.organization.KnowledgeOrganization newKnowledgeOrganization,
			boolean update) {
		knowledgeOrganization = newKnowledgeOrganization;
		if (update) {
			if (m_bindingContext != null) {
				m_bindingContext.dispose();
				m_bindingContext = null;
			}
			if (knowledgeOrganization != null) {
				m_bindingContext = initDataBindings();
			}
		}
	}

}
